    /*

    Copyright (C) 1999 Stefan Westerfeld
                       stefan@space.twc.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    */

#ifndef __STRUCTURE_H_
#define __STRUCTURE_H_

#include "synth.h"
#include "module.h"

class Structure
{
	Arts::Synthesizer *Synthesizer;
	Arts::StructureDesc_var StructureDesc;

	list<Module *> ModuleList;
	long execID;

public:
	Structure(Arts::Synthesizer *Synthesizer);
	~Structure();

	void startExecute();
	void stopExecute();
	bool isExecuting();

	void loadOld(const char *filename);
	void load(const char *filename);
	void retrieve(const char *pubname);
	void loadFromList(Arts::StringSeq *strseq);
	void save(const char *filename);
	void clear();
	void publish();

	long countSelected();
	void deleteSelected();

	char *name();
	void rename(const char *newname);

	Module *createModule(const Arts::ModuleInfo *minfo);

	list<Module *> *getModuleList();
};

#endif
